LeetCode 95, 96. Unique Binary Search Trees i. ii

1. 题目描述

95.Given n, generate all structurally unique BST’s (binary search trees) that store values 1…n.
96.Given n, how many structurally unique BST’s (binary search trees) that store values 1…n?
For example,
Given n = 3, your program should return all 5 unique BST’s shown below.

  1         3     3      2      1
   \       /     /      / \      \
    3     2     1      1   3      2
   /     /       \                 \
  2     1         2                 3

2. 解题思路

拿到这道题目第一感觉是采用动态规划来处理。因为这是一个BST树, 我们可以抽取任意节点作为根节点来构建一颗BST 树。然后使用递归来处理。

3. code

3.1 95

class Solution {
public:
    vector<TreeNode*> generateTrees(int n) {
        if (n < 1)
            return vector<TreeNode *>();
        return generateTrees(1, n + 1);
    }

private:
    vector<TreeNode*> generateTrees(int start, int stop){
        if (start >= stop)
            return vector<TreeNode*>{nullptr};

        vector<TreeNode*> res;
        for (int i = start; i != stop; i++){
            vector<TreeNode*> left = generateTrees(start, i);
            vector<TreeNode*> right = generateTrees(i + 1, stop);

            for (int j = 0; j != left.size(); j++){
                for (int k = 0; k != right.size(); k++){
                    TreeNode * cur = new TreeNode(i);
                    cur->left = left[j];
                    cur->right = right[k];
                    res.push_back(cur);
                }
            }
        }
        return res;
    }
};

3.2 96

带备份的DP

class Solution {
public:
    int numTrees(int n) {
        data = vector<int>(n, 0);
        return _numTrees(n);
    }

private:
    vector<int> data;
    int _numTrees(int n){
        if (n <= 0)
            return 0;

        if (n > 0 && data[n - 1])
            return data[n - 1];

        int res = 0;
        for (int i = 0; i < n; i++){
            int left = _numTrees(i);
            int right = _numTrees(n - i - 1);
            res += max(left, 1) * max(right, 1);
        }
        data[n - 1] = res;
        return res;
    }
};

4. 大神解法

4.1 96 dp

这是一个用迭代实现的DP

/*
The problem can be solved in a dynamic programming way. I’ll explain the intuition and formulas in the following.

Given a sequence 1…n, to construct a Binary Search Tree (BST) out of the sequence, we could enumerate each number i in the sequence, and use the number as the root, naturally, the subsequence 1…(i-1) on its left side would lay on the left branch of the root, and similarly the right subsequence (i+1)…n lay on the right branch of the root. We then can construct the subtree from the subsequence recursively. Through the above approach, we could ensure that the BST that we construct are all unique, since they have unique roots.

The problem is to calculate the number of unique BST. To do so, we need to define two functions:

G(n): the number of unique BST for a sequence of length n.

F(i, n), 1 <= i <= n: the number of unique BST, where the number i is the root of BST, and the sequence ranges from 1 to n.

As one can see, G(n) is the actual function we need to calculate in order to solve the problem. And G(n) can be derived from F(i, n), which at the end, would recursively refer to G(n).

First of all, given the above definitions, we can see that the total number of unique BST G(n), is the sum of BST F(i) using each number i as a root. i.e.

G(n) = F(1, n) + F(2, n) + ... + F(n, n). 
Particularly, the bottom cases, there is only one combination to construct a BST out of a sequence of length 1 (only a root) or 0 (empty tree). i.e.

G(0)=1, G(1)=1. 
Given a sequence 1…n, we pick a number i out of the sequence as the root, then the number of unique BST with the specified root F(i), is the cartesian product of the number of BST for its left and right subtrees. For example, F(3, 7): the number of unique BST tree with number 3 as its root. To construct an unique BST out of the entire sequence [1, 2, 3, 4, 5, 6, 7] with 3 as the root, which is to say, we need to construct an unique BST out of its left subsequence [1, 2] and another BST out of the right subsequence [4, 5, 6, 7], and then combine them together (i.e. cartesian product). The tricky part is that we could consider the number of unique BST out of sequence [1,2] as G(2), and the number of of unique BST out of sequence [4, 5, 6, 7] as G(4). Therefore, F(3,7) = G(2) * G(4).

i.e.

F(i, n) = G(i-1) * G(n-i)   1 <= i <= n 
Combining the above two formulas, we obtain the recursive formula for G(n). i.e.

G(n) = G(0) * G(n-1) + G(1) * G(n-2) + … + G(n-1) * G(0) 
In terms of calculation, we need to start with the lower number, since the value of G(n) depends on the values of G(0) … G(n-1).

With the above explanation and formulas, here is the implementation in Java.
*/
public int numTrees(int n) {
    int [] G = new int[n+1];
    G[0] = G[1] = 1;

    for(int i=2; i<=n; ++i) {
        for(int j=1; j<=i; ++j) {
            G[i] += G[j-1] * G[i-j];
        }
    }

    return G[n];
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值